﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=SMM_Example2_TEST.zip

Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI

	Private CustomListView1 As CustomListView
	Private PreoptimizedCLV1 As PreoptimizedCLV
	
	Private SimpleMediaManager1 As SimpleMediaManager
	Private Extra As Map

	Type TypeImageData (IndexOfFirstImage As Int)
End Sub

Public Sub Initialize
	B4XPages.GetManager.TransitionAnimationDuration = 0
	SimpleMediaManager1.Initialize
	CustomListView1.AnimationDuration = 0
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	B4XPages.SetTitle(Me, "SMM Example #2")
	Root = Root1
	Root.LoadLayout("1")
	
'	SetMediaWithExtra
	Extra.Initialize
	Extra.Put(SimpleMediaManager1.REQUEST_BACKGROUND, xui.Color_White)
	Extra.Put(SimpleMediaManager1.REQUEST_FADE_ANIMATION_DURATION, 0)
	Extra.Put(SimpleMediaManager1.REQUEST_RESIZE_MODE, "FILL")
'	Extra.Put(SimpleMediaManager1.REQUEST_ROUNDIMAGE, True) 'Only Extras default False
	Extra.Put(SimpleMediaManager1.REQUEST_CALLBACK, Me) 'Only Extras
	
'	SetMedia Default
	SimpleMediaManager1.DefaultBackgroundColor = xui.Color_White 'or Extras
	SimpleMediaManager1.DefaultFadeAnimationDuration = 0 'or Extras
	SimpleMediaManager1.DefaultResizeMode = "FILL" 'or Extras

'	General SMM
	SimpleMediaManager1.DefaultRequestTimeout = 60 * DateTime.TicksPerSecond
	SimpleMediaManager1.SleepDurationBeforeDownload = 30
	SimpleMediaManager1.MaxImageSize = 300
	
	SimpleMediaManager1.DefaultErrorRequest.Extra.Put(SimpleMediaManager1.REQUEST_BACKGROUND, xui.Color_LightGray)
	SimpleMediaManager1.AddLocalMedia(SimpleMediaManager1.KEY_DEFAULT_ERROR, xui.LoadBitmap(File.DirAssets, "error.png"), "image/*")
	SimpleMediaManager1.AddLocalMedia(SimpleMediaManager1.KEY_DEFAULT_LOADING, File.ReadBytes(File.DirAssets, "loading.gif"), "image/gif")
	
	PreoptimizedCLV1.Initialize(Me, "PreoptimizedCLV1", CustomListView1)
	PreoptimizedCLV1.pnlOverlay.Color = xui.Color_Transparent
	PreoptimizedCLV1.DelayBeforeHidingOverlay = 0
	
	Dim Height As Int = IIf(xui.IsB4J, 200dip, 150dip)
	For i = 1 To 1084 Step 4
		PreoptimizedCLV1.AddItem(Height, xui.Color_White, CreateTypeImageData(i))
	Next
	
	PreoptimizedCLV1.ShowScrollBar = True
	PreoptimizedCLV1.ExtraItems = 4
	PreoptimizedCLV1.Commit
End Sub

Public Sub PreoptimizedCLV1_HintRequested (Index As Int) As Object
'	Log(Index)
	Return Null
End Sub

Public Sub  B4XPage_Resize (Width As Int, Height As Int)
'	Log("B4XPages_Resize")
End Sub

Sub CustomListView1_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	For Each i As Int In PreoptimizedCLV1.VisibleRangeChanged(FirstIndex, LastIndex)
		Dim Item As CLVItem = CustomListView1.GetRawListItem(i)
		Dim Data As TypeImageData = Item.Value
		
		Dim p As B4XView = xui.CreatePanel("")
		Item.Panel.AddView(p, 0, 0, Item.Panel.Width, Item.Panel.Height)
		p.LoadLayout("item")

		For x = 0 To 3
			Dim ItemParent As B4XView = p.GetView(x)
			Dim MediaPanel As B4XView = ItemParent.GetView(0)
			Dim MediaLabel As B4XView = ItemParent.GetView(1)

			Dim URL As String =  $"https://picsum.photos/id/${Data.IndexOfFirstImage + x}/200/300.jpg"$
			MediaLabel.Text = Data.IndexOfFirstImage + x

'			MediaPanel.SetColorAndBorder(0, 0, 0, 30) 'Before none
			
'			SimpleMediaManager1.SetMedia(MediaPanel,URL) 'Test Default
			SimpleMediaManager1.SetMediaWithExtra(MediaPanel, URL, "", Extra) 'Test Extras
			
'			MediaPanel.SetColorAndBorder(0, 0, 0, 30) 'After
			SetRectangleClip(MediaPanel, 30) 'Rectangle View (CornersRadius)
		Next
	Next
	
	'The purpose of this call is to find panels that are no longer in the views tree and cancel any ongoing request that is no longer relevant.
	'It also happens automatically from time to time but in this case, as many requests are sent frequently, it is better to force it to trim the cache.
	'Note that you need to add HU2_PUBLIC to the build configuration.
	SimpleMediaManager1.TrimMediaCache
End Sub

Private Sub SMM_MediaReady (Success As Boolean, Media As SMMedia)
'	Log(Success)
'	Log(Media.MediaState)
'	Log(Media.Media)
'	Log(SimpleMediaManager1.IsWebPAnimated(Media))
'	Log(Media.Meta.MediaType)
End Sub

Public Sub SetRectangleClip(pnl As B4XView, CornersRadius As Double)
	pnl.SetColorAndBorder(0, 0, 0, CornersRadius)
	#If B4J
	Dim Rectangle As JavaObject
	Dim cx = pnl.Width, cy = pnl.Height As Double
	Rectangle.InitializeNewInstance("javafx.scene.shape.Rectangle", Array(cx, cy))
	If CornersRadius > 0 Then
		Rectangle.RunMethod("setArcHeight", Array(CornersRadius))
		Rectangle.RunMethod("setArcWidth", Array(CornersRadius))
	End If
	pnl.As(JavaObject).RunMethod("setClip", Array(Rectangle))
	#Else If B4A
	pnl.As(JavaObject).RunMethod("setClipToOutline", Array(CornersRadius > 0))
	#End If
End Sub

Public Sub CreateTypeImageData (IndexOfFirstImage As Int) As TypeImageData
	Dim t1 As TypeImageData
	t1.Initialize
	t1.IndexOfFirstImage = IndexOfFirstImage
	Return t1
End Sub
